<?php 

error_log("adhoc loaded");

global $URL_HANDLERS;
$URL_HANDLERS["adhoc.*"] = "GLCASAdhoc";
global $BASE_URL, $MENU_ITEMS;
$MENU_ITEMS["20adhoc"]["name"] = "Adhoc Packages";
$MENU_ITEMS["20adhoc"]["link"] = "$BASE_URL/adhoc";


class GLCASAdhoc {
	function __construct($config)
	{
		$this->config = $config;
		error_log("constructor for GLCASAdhoc");
		
		$repostore = $this->config->getConfig("storagelocation");
		if(!is_dir("$repostore/adhoc")) {
			error_log("Creating dir for adhoc component");
			mkdir("$repostore/adhoc");
		}
		
	}
	
	function go($url)
	{
		error_log("ADHOC: url is $url in");
		$tags = explode("/", $url);
		if(isset($tags[1])) {
			error_log("tags 1 is set: \"".$tags[1]."\"");
			if($tags[1] != "") {
				if($this->doPackageRequest($tags[1])) return 0;
			} else {
				GLCASpageBuilder($this, "doPackageList");
				return 0;
			}
		}
		if(isset($_REQUEST["action"])) {
			switch($_REQUEST["action"]) {
				case "addpackage":
					error_log("in updaterepo");
					GLCASpageBuilder($this,"addPackage");
					return;
				case "deletepkg":
					error_log("in delete pkg");
					GLCASpageBuilder($this, "delPackage");
					return;
			}
		}
		
		GLCASpageBuilder($this,"mainBody");
		return;
		
	}
	
	function doPackageList()
	{
		echo "im a package list\n";
	}
	
	function doPackageRequest($package)
	{
		echo "i got a request for $package\n";
		
		return true;
	}
	
	function delPackage($url)
	{	
		$repostore = $this->config->getConfig("storagelocation");
		
		$pkgid = $_REQUEST["pkgid"];
		$pkgname = $_REQUEST["pkgname"];
		
		$this->config->delAllData("adhocpkgdata", $pkgid);
		$this->config->delData("adhoc", "pkglist", "$pkgname", "$pkgid");
		
		global $WEB_ROOT_FS, $URL_HANDLERS, $BASE_URL;
		header("Location: $BASE_URL/adhoc");
		
		
	}
	
	function addPackage($url)
	{
		$repostore = $this->config->getConfig("storagelocation");
		
		if(!isset($_REQUEST["pkgname"])) {
			if(isset($_REQUEST["origpkg"])) if($_REQUEST["origpkg"] == -1) {
				echo "<font color=\"red\">Error: No package name set</font><br>";
				return 0;
			}
		} 
		if($_REQUEST["pkgname"] == "") {
			if(isset($_REQUEST["origpkg"])) if($_REQUEST["origpkg"] == -1) {
				echo "<font color=\"red\">Error: Package name cant be blank</font><br>";
				return 0;
			}
		}
		

		$fname = "";
		$lname = "";
		$ultfileurl = "";
		if($_FILES["uploadedfile"]["name"] == "") {
			$uploaded = false;
			$ultfileurl = "uploaded";
		} else {
			$fname = $_FILES["uploadedfile"]["tmp_name"];
			$lname = $_FILES["uploadedfile"]["name"];
			$uploaded = true;
		}
		
		if($_REQUEST["fileurl"] == "") {
			$fileurl = false;
			$ultfileurl = $_REQUEST["fileurl"];
		} else {
			$fname = $_REQUEST["fileurl"];
			$lname = basename($fname);
			$fileurl = true;
		}
		
		if(!$uploaded && !$fileurl) {
			echo "<font color=\"red\">Error: no uploaded file and no file url, you need one or the other buddy</font><br>";
			return 0;
		}
		
		$getfile = "";
		if($fileurl) {
			$getfile = file_get_contents($_REQUEST["fileurl"]);
		} 
		
		if($uploaded||$fileurl) {
			echo "Got a file named $fname, $lname";
		}
		
		$myname = $_REQUEST["pkgname"];
		$myarch = $_REQUEST["arch"];
		$mytype = $_REQUEST["type"];
		$myfileurl = $ultfileurl;
		
		if(isset($_REQUEST["origpkg"])) if($_REQUEST["origpkg"] != -1) {
			$n = $_REQUEST["origpkg"];
			$this->config->addData("adhocpkgdata", "$n", "arch", $myarch);
			$this->config->addData("adhocpkgdata", "$n", "type", $mytype);
			$outputfile = "$repostore/adhoc/$n.$myarch.$mytype";
			if($uploaded) {
				copy("$fname", "$outputfile");
			} else {
				file_put_contents("$outputfile", $getfile);
			}
			
			global $WEB_ROOT_FS, $URL_HANDLERS, $BASE_URL;
			header("Location: $BASE_URL/adhoc");
			return 0;
		}
		
		// assuming add a new
		$n = 0;
		$pkglist = $this->config->getData("adhoc", "pkglist");
		if($pkglist !== false) foreach($pkglist as $key => $val) {
			$n = $val["name"]+1;
		}

		error_log("would add package as $n");
		
		$this->config->addData("adhoc", "pkglist", "$myname", $n);
		$this->config->addData("adhocpkgdata", "$n", "arch", $myarch);
		$this->config->addData("adhocpkgdata", "$n", "type", $mytype);
		
		
		$outputfile = "$repostore/adhoc/$n.$myarch.$mytype";
		if($uploaded) {
			copy("$fname", "$outputfile");
		} else {
			file_put_contents("$outputfile", $getfile);
		}
		
		global $WEB_ROOT_FS, $URL_HANDLERS, $BASE_URL;
		header("Location: $BASE_URL/adhoc");

	}
	
	
	function mainBody($url)
	{
		echo "<h2>Packages</h2>";

		/* TODO: to new config
		$pkgs = unserialize($this->config->getConfig("adhocpackages"));
		*/
		$pkgs = $this->config->getData("adhoc");
		//print_r($pkgs);
		if($pkgs !== false) {
			echo "<table border=\"1\"><tr><th>Name</th><th>Package Types</th><th>Architecture</th><th>Control</th></tr>";
			
			foreach($pkgs as $key => $var) {
				$name = $var["name"];
				$id = $var["val"];
				$arch_v = $this->config->getData("adhocpkgdata", $id, "arch");
				$arch = $arch_v[0]["val"];
				$type_v = $this->config->getData("adhocpkgdata", $id, "type");
				$type = $type_v[0]["val"];
				echo "<tr><td>$name</td><td>$type</td><td>$arch</td><td><a href=\"?action=deletepkg&pkgid=$id&pkgname=$name\">Delete</a></td></tr>";
				if(count($arch_v) > 1) {
					for($i=1; $i < count($arch_v); $i++) {
						$arch = $arch_v[$i]["val"];
						$type_v = $this->config->getData("adhocpkgdata", $id, "type");
						$type = $type_v[$i]["val"];
						echo "<tr><td></td><td>$type</td><td>$arch</td><td></td></tr>";
					}
				}
			}
			echo "<table>";
		}
			
		$kos = getKnownOSList();
		
		echo "<hr>";
		echo "<h3>Add a Package</h3><br>";
		echo "<form enctype=\"multipart/form-data\" method=\"post\" action=\"?action=addpackage\">";
		echo "Name <input type=\"text\" name=\"pkgname\">";
		if($pkgs !== false) {
			echo "or Add version of <select name=\"origpkg\">";
			echo "<option value=\"-1\" default>None</option>";
			foreach($pkgs as $key=>$var) {
				$id = $var["val"];
				$name = $var["name"];
				echo "<option value=\"$id\">$name</option>";
			}
			echo "</select><br>";
		}
		else echo "<br>";
		echo "Arch <select name=\"arch\">";
		foreach($kos["pkgarch"] as $key => $val) {
			echo "<option value=\"$key\">$val</option>";
		}
		echo "</select><br>";
		echo "Type <select name=\"type\">";
		foreach($kos["pkg"] as $key => $val) {
			echo "<option value=\"$key\">$val</option>";
		}
		echo "</select><br>";
		echo "Upload <input type=\"file\" name=\"uploadedfile\"><br>";
		echo "From URL <input type=\"text\" name=\"fileurl\"><br>";
		echo "<input type=\"submit\" name=\"add\" value=\"Add\">";
		echo "</form>";
	}
	
	private $config;
}

?>
